1. 程式人生 > >HDU 3535 AreYouBusy(組合背包)

HDU 3535 AreYouBusy(組合背包)

problem input clu include for each ted 錯誤 多少 line

傳送門

AreYouBusy

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4362 Accepted Submission(s): 1761

Description

Happy New Term!
As having become a junior, xiaoA recognizes that there is not much time for her to AC problems, because there are some other things for her to do, which makes her nearly mad.


What‘s more, her boss tells her that for some sets of duties, she must choose at least one job to do, but for some sets of things, she can only choose at most one to do, which is meaningless to the boss. And for others, she can do of her will. We just define the things that she can choose as "jobs". A job takes time , and gives xiaoA some points of happiness (which means that she is always willing to do the jobs).So can you choose the best sets of them to give her the maximum points of happiness and also to be a good junior(which means that she should follow the boss‘s advice)?

Input

There are several test cases, each test case begins with two integers n and T (0<=n,T<=100) , n sets of jobs for you to choose and T minutes for her to do them. Follows are n sets of description, each of which starts with two integers m and s (0<m<=100), there are m jobs in this set , and the set type is s, (0 stands for the sets that should choose at least 1 job to do, 1 for the sets that should choose at most 1 , and 2 for the one you can choose freely).then m pairs of integers ci,gi follows (0<=ci,gi<=100), means the ith job cost ci minutes to finish and gi points of happiness can be gained by finishing it. One job can be done only once.

Output

One line for each test case contains the maximum points of happiness we can choose from all jobs .if she can’t finish what her boss want, just output -1 .

Sample Input

3 3
2 1
2 5
3 8
2 0
1 0
2 1
3 2
4 3
2 1
1 1

3 4
2 1
2 5
3 8
2 0
1 1
2 8
3 2
4 4
2 1
1 1

1 1
1 0
2 1

5 3
2 0
1 0
2 1
2 0
2 2
1 1
2 0
3 2
2 1
2 1
1 5
2 8
3 2
3 8
4 9
5 10

Sample Output

5
13
-1
-1

思路

題意:有n類工作,給定時間T,每類工作有m種事情,第0類表示至少選一件事做,第1類表示至多選一件事做,第2類表示你可以自由選擇。給出每件事所需的時間c以及完成事件後得到的成就感g。問在時間T內,按照規定的要求,所能獲得的最大成就是多少。

思路:dp[i][j]表示第 i 組,時間 j 能獲得的最大成就。

第一類:至少選一項,因此初始化的時候d,這一組的dp值全部賦值為-INF,dp[i - 1][j - c] + v 表示第一次選擇本組中的物品。由於開始時將該組dp賦值-INF,所以第一次取時,必須由上一組的結果推知,這樣才能保證得到全局最優解;

第二類:最多選一項,要麽不選,要麽一組只能選擇一項。因此轉移方程容易寫出 dp[i][j] = max(dp[i][j],dp[i-1][j-c] + v)。由於要保證得到全局最優解,所以在該組DP開始以前,應該將上一組的DP結果先復制到這一組的dp[i]數組裏,因為當前組的數據是在上一組數據的基礎上進行更新的。

第三類就是簡單的01背包問題。同樣,為了保證全局最優解,要先復制上一組的解。

#include<bits/stdc++.h>
using namespace std;
const int INF = (1<<30);
const int maxn = 105;
int dp[maxn][maxn];

int main()
{
	//freopen("input.txt","r",stdin);
	int n,T;
	while (~scanf("%d%d",&n,&T))
	{
		int m,s,c,v;
		memset(dp,0,sizeof(dp));
		for (int i = 1;i <= n;i++)
		{
			scanf("%d%d",&m,&s);
			if (s == 0)
			{
				for (int j = 0;j <= T;j++)	dp[i][j] = -INF;
				while (m--)
				{
					scanf("%d%d",&c,&v);
					for (int j = T;j >= c;j--)
					{
						dp[i][j] = max(dp[i][j],max(dp[i-1][j-c] + v,dp[i][j-c] + v));
					}
				}
			}
			else if (s == 1)
			{
				for (int j = 0;j <= T;j++)	dp[i][j] = dp[i-1][j];
				while (m--)
				{
					scanf("%d%d",&c,&v);
					for (int j = T;j >= c;j--)
					{
						dp[i][j] = max(dp[i][j],dp[i-1][j-c] + v);
						//註意以下順序是錯誤的,因為當c = 0時,dp[i][j]會加兩次v 
						//dp[i][j] = max(dp[i][j],dp[i-1][j-c] + v);
                        //dp[i][j] = max(dp[i][j],dp[i][j-c] + v);
					}
				}
			}
			else if (s == 2)
			{
				for (int j = 0;j <= T;j++)	dp[i][j] = dp[i-1][j];
				while (m--)
				{
					scanf("%d%d",&c,&v);
					for (int j = T;j >=c;j--)
					{
						dp[i][j] = max(dp[i][j],dp[i][j-c] + v);
						dp[i][j] = max(dp[i][j],dp[i-1][j-c] + v);
					}
				}
			}
		}
		printf("%d\n",max(dp[n][T],-1));
	}
	return 0;
} 

  

HDU 3535 AreYouBusy(組合背包)